/**
 * @file  sci.c
 * @brief SCIhCo
 *
 * @version: 1.4 2022/8/30, $Id $
 *
 * {\tgEFA̒쌠͍쐬ł()kldqL̂ƂA
 * ()kldq́Aȉ (1)-(3) ̏𖞂ꍇɌA
 * {\tgEFAi{\tgEFAς̂܂ށBȉj
 * gpEEρEĔzziȉApƌĂԁj邱Ƃ𖳏ŋB
 *
 * (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́AL̒
 *	   \A̗pÂ܂܂̌`Ń\[XR[hɊ܂܂
 *	   邱ƁB
 * (2) {\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ֎~
 *	   ƂBGȂǂ֏ЉE^̏ꍇ()kldqɘA肢܂B
 * (3) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *	   A()kldq͈؂̐ӔC𕉂Ȃ̂ƂB
 *
 * Copyright (C) Hokuto denshi Co,Ltd. 2021-2022
 */

/*----------------------------------------------------------------------
	CN[h
----------------------------------------------------------------------*/
#include	"sci.h"

/*----------------------------------------------------------------------
	vg^Cv錾
----------------------------------------------------------------------*/
void sci_start(void);
void sci_stop(void);
void sci_write_char(unsigned char c);
void sci_write_uint8_hex(unsigned char c);
void sci_write_uint16_hex(unsigned short s);
void sci_write_uint32_hex(unsigned long l);
void sci_write_uint8(unsigned char num);
void sci_write_uint16(unsigned short num);
void sci_write_uint32(unsigned long num);
void sci_write_int8(char num);
void sci_write_int16(short num);
void sci_write_int32(long num);
void sci_write_str(const char *str);
void sci_write_flush(void);
unsigned short sci_read_char(unsigned char *c);
unsigned short sci_read_str(char *str, unsigned short size);
unsigned short sci_read_data_size(void);
void sci_read_buf_clear(void);
int float2str(float value, int num, char *str);
int float2str_eformat(float value, int num, char *str);
int double2str(double value, int num, char *str);
int double2str_eformat(double value, int num, char *str);

void intr_sci_send_end(void);
void intr_sci_receive_end(void);
void intr_sci_receive_error(void);

static int interrupt_flag_get(void);

#if defined(MCU_TYPE_RA)
//FSPŐݒ肵荞݃R[obN֐
void user_uart_callback (uart_callback_args_t * p_args);
#endif

/*----------------------------------------------------------------------
	O[oϐit@Cj
----------------------------------------------------------------------*/
static const unsigned char hex_table_char[] = "0123456789ABCDEF";		// e[u
//static const unsigned char hex_table_char[] = "0123456789abcdef";		// e[ui\j

/*----------------------------------------------------------------------
	O[oϐ
----------------------------------------------------------------------*/
unsigned char g_sci_send_buf[2][SCI_SEND_BUF_SIZE];			//Mobt@
unsigned char g_sci_recv_buf[SCI_RECV_BUF_SIZE];			//Mobt@

volatile unsigned short g_sci_send_buf_index[2] = {0, 0};	//i[ς݃CfbNXiMj
volatile unsigned short g_sci_recv_buf_index1 = 0;			//i[ς݃CfbNXiMj
volatile unsigned short g_sci_recv_buf_index2 = 0;			//ǂݏoς݃CfbNXiM)
volatile unsigned char g_sci_send_buf_page_index = 0;		//i[y[WCfbNXiMj
volatile unsigned char g_sci_send_flag = FLAG_CLEAR;		//MtOiMj
volatile unsigned char g_sci_send_nowait_flag = FLAG_CLEAR;	//MEFCgsȂtOiMj
volatile unsigned char g_sci_status = 0;					//Xe[^X
volatile unsigned char g_sci_start = FLAG_CLEAR;			//W[Xe[^X

unsigned char g_sci_recv_data;								//Mf[^iMj

/*----------------------------------------------------------------------
	\[XR[h
----------------------------------------------------------------------*/

void sci_start( void )
{
	//SCIJn֐
	
	if (FLAG_SET == g_sci_start)
	{
		//RADTCLɂꍇSCI_START̑OSCI_STOPsꍇG[nhɔԂ̂
		//ݓ쒆mFĒ~lɂ
		
		SCI_STOP;
	}
	
	g_sci_send_buf_index[0] = 0;
	g_sci_send_buf_index[1] = 0;
	g_sci_recv_buf_index1 = 0;
	g_sci_recv_buf_index2 = 0;
	g_sci_send_buf_page_index = 0;
	g_sci_send_flag = FLAG_CLEAR;
	g_sci_send_nowait_flag = FLAG_CLEAR;
	g_sci_status = 0;
	
	SCI_START;
	g_sci_start = FLAG_SET;
	
	//1M
	SCI_RECEIVE(&g_sci_recv_data, 1);
}

void sci_stop( void )
{
	//SCI~֐
	
	if (FLAG_SET == g_sci_start)
	{
		//RADTCLɂꍇSCI_START̑OSCI_STOPsꍇG[nhɔԂ̂
		//ݓ쒆mFĒ~lɂ
		
		SCI_STOP;
		g_sci_start = FLAG_CLEAR;
	}
}

void sci_write_char( unsigned char c )
{
	//1M֐iMobt@i[֐j
	
	//^ꂽ𑗐Mobt@Ɋi[
	
	//
	// unsigned char c : R[h
	
	int i_flag = interrupt_flag_get();
	
	while (g_sci_send_buf_index[g_sci_send_buf_page_index] >= SCI_SEND_BUF_SIZE)
	{
		//obt@t܂Ń[v
		
		//荞݋֎~ԁAobt@tŖ{֐ĂяoƖ[vƂȂ̂
		//̏ꍇ̓obt@t҂f[^̂Ăă^[
		
		if ((g_sci_send_nowait_flag == FLAG_SET) || (i_flag == 0))
		{
			g_sci_status |= SCI_SEND_BUF_OVERFLOW;
			
			return;		//nowaittOݒ肳Ă鎞A܂͊݋֎~̓f[^i[Ɏ̂Ă
		}
		
		//while[vɓŊ݋֎~ɂȂꍇA[vɂȂ̂
		//݋֎~EtO͐`FbN
		i_flag = interrupt_flag_get();
	}
	
	//Mobt@ƃCfbNXɕsƕ\Ȃ̂ŁAMobt@i[ƃCfbNXCNgԂ̊荞݂֎~
	if(i_flag) INTERRUPT_DISABLE;	//݃tOɂ菈eςKv͂ȂAX݋֎~͉̎Ȃ
	g_sci_send_buf[g_sci_send_buf_page_index][g_sci_send_buf_index[g_sci_send_buf_page_index]++] = c;	//Mobt@Ɋi[ & CfbNXCNg
	if(i_flag) INTERRUPT_ENABLE;	//荞݋֎~ԂŖ{֐Ă΂ꂽꍇ͊荞݂Ȃ
	
	NOP_MCU_DEP;		//荞݋֎~Ɋ荞݃tOۂ͂NOP߂̎sA荞ݏɔ(RL78)
	
	if (g_sci_send_flag == FLAG_CLEAR)   //Mł͂Ȃ
	{
		g_sci_send_flag = FLAG_SET;
		
		//M֐LbN
		
		if(i_flag) INTERRUPT_DISABLE;
		
		//{Iɂ SCI_SEND() s瑗MI荞݂܂ł͂xԓIȗP\̂
		//荞݋֎~ƂKv͔Ôߊ荞݋֎~ݒŏs
		
#if defined(MCU_TYPE_RH850)
		
		//-RH850ł̑MCu֐Ăяo̒ӓ_-
		
		//RH850̓}CR̋@\ƂĂ͑M荞݂|鎖\ł邪
		//uMGveB荞݁vƁuM荞݁vĂȂ
		
		//X}[gRtBO[^̐R[h͑Mobt@ɂȂ^C~Oł̊荞݂ƂȂ
		//uMGveB荞݁vŒ̃R[h
		
		//M SCI_SEND Ăяo MD_ERROR Ԃ̂ŁÂƂ͍ēx SCI_SEND Ăяo
		//ő1LN^̑MԂ̃EFCgƂȂ̂ŁA
		//ŏIf[^MɁAM荞݂̐ݒύXAX}[gRtBO[^̃R[hύXvƂȂ邽
		//̓EFCg[vőΉ
		
		//ŏIf[^MɁAM荞݂uMGveB荞݁v->uM荞݁vɐݒ
		//(LUOR1.UTIGTS = 1)ꍇ́Ał̃EFCg͕svƂȂ
		
		//[*dv*]115,200bps̏ꍇAő86usx̑҂鎖ɂȂ̂Œ
		
		while (MD_ERROR == SCI_SEND(&g_sci_send_buf[g_sci_send_buf_page_index][0], g_sci_send_buf_index[g_sci_send_buf_page_index]) )
		{
			NOP_MCU_DEP;
		}
#else
		SCI_SEND(&g_sci_send_buf[g_sci_send_buf_page_index][0], g_sci_send_buf_index[g_sci_send_buf_page_index]);
#endif
		
		g_sci_send_buf_index[g_sci_send_buf_page_index] = 0;	//i[ς݃CfbNXNA
		
		g_sci_send_buf_page_index++;	//Mobt@̃y[W؂ւ
		if (g_sci_send_buf_page_index >= 2) g_sci_send_buf_page_index = 0;
		
		if(i_flag) INTERRUPT_ENABLE;	//荞݋֎~ԂŖ{֐Ă΂ꂽꍇ͊荞݂Ȃ
		
		NOP_MCU_DEP;
	}
}

void sci_write_uint8_hex(unsigned char c)
{
	//^ꂽhex(00-FF)2ŕ\֐
	
	//
	//  unsigned char c : \R[h(8bit)
	
	sci_write_char(hex_table_char[((c & 0xf0) >> 4)]);
	sci_write_char(hex_table_char[(c & 0x0f)]);
}

void sci_write_uint16_hex(unsigned short s)
{
	//^ꂽhex(0000-FFFF)4ŕ\֐
	
	//
	//  unsigned short s : \R[h(16bit)
	
	unsigned char c;
	
	c = (unsigned char)((s & 0xff00) >> 8);
	sci_write_uint8_hex(c);
	
	c = (unsigned char)(s & 0x00ff);
	sci_write_uint8_hex(c);
}

void sci_write_uint32_hex(unsigned long l)
{
	//^ꂽhex(00000000-FFFFFFFF)8ŕ\֐
	
	//
	//  unsigned long l : \R[h(32bit)
	
	unsigned char c;
	
	c = (unsigned char)((l & 0xff000000) >> 24);
	sci_write_uint8_hex(c);
	
	c = (unsigned char)((l & 0x00ff0000) >> 16);
	sci_write_uint8_hex(c);
	
	c = (unsigned char)((l & 0x0000ff00) >> 8);
	sci_write_uint8_hex(c);
	
	c = (unsigned char)(l & 0x000000ff);
	sci_write_uint8_hex(c);
}

void sci_write_uint8(unsigned char num)
{
	//^ꂽl10iŕ\֐
	
	//
	//  unsigned char num : \liȂj
	
	unsigned char n[3];
	
	n[0]  = num % 10;
	num  /= 10;
	n[1]  = num % 10;
	num  /= 10;
	n[2]  = num % 10;
	
	if (n[2] != 0)
	{
		sci_write_char(hex_table_char[n[2]]);
		sci_write_char(hex_table_char[n[1]]);
	}
	else if (n[1] != 0)
	{
		sci_write_char(hex_table_char[n[1]]);
	}
	
	sci_write_char(hex_table_char[n[0]]);
}

void sci_write_uint16(unsigned short num)
{
	//^ꂽl10iŕ\֐
	
	//
	//  unsigned short num : \liȂj
	
	unsigned char n[5];
	unsigned short i, j;
	
	for (i=0; i<5; i++)
	{
		n[i] = (unsigned char)(num % 10);
		if (i == 4) break;
		num /= 10;
	}
	
	for (i=4; i>=1; i--)
	{
		if (n[i] != 0) break;
	}
	
	for (j=i; j>=1; j--) sci_write_char(hex_table_char[n[j]]);
	
	sci_write_char(hex_table_char[n[0]]);
}

void sci_write_uint32(unsigned long num)
{
	//^ꂽl10iŕ\֐
	
	//
	//  unsigned long num : \liȂj
	
	unsigned char n[10];
	unsigned short i, j;
	
	for (i=0; i<10; i++)
	{
		n[i] = (unsigned char)(num % 10L);
		if (i == 9) break;
		num /= 10L;
	}
	
	for (i=9; i>=1; i--)
	{
		if (n[i] != 0) break;
	}
	
	for (j=i; j>=1; j--) sci_write_char(hex_table_char[n[j]]);
	
	sci_write_char(hex_table_char[n[0]]);
}

void sci_write_int8(char num)
{
	//^ꂽl10iŕ\֐
	
	//
	//  char num : \litj
	
	unsigned char n[3];
	
	if ((num & 0x80) == 0x80)
	{
		sci_write_char('-');
		num = (char)~num;
		num = (char)(num + 1);
	}
	
	n[0]  = (unsigned char)(num % 10);
	num  /= 10;
	n[1]  = (unsigned char)(num % 10);
	num  /= 10;
	n[2]  = (unsigned char)(num % 10);
	
	if (n[2] != 0)
	{
		sci_write_char(hex_table_char[n[2]]);
		sci_write_char(hex_table_char[n[1]]);
	}
	else if (n[1] != 0)
	{
		sci_write_char(hex_table_char[n[1]]);
	}
	
	sci_write_char(hex_table_char[n[0]]);
}

void sci_write_int16(short num)
{
	//^ꂽl10iŕ\֐
	
	//
	//  short num : \litj
	
	if (num < 0)
	{
		sci_write_char('-');
		num = (short)(num * (-1));
	}
	
	sci_write_uint16((unsigned short)num);
}

void sci_write_int32(long num)
{
	//^ꂽl10iŕ\֐
	
	//
	//  long num : \litj
	
	if (num < 0)
	{
		sci_write_char('-');
		num *= -1L;
	}
	
	sci_write_uint32((unsigned long)num);
}

void sci_write_str(const char *str)
{
	//\֐
	
	//
	//  char *str : \̃|C^i'\0'I[j
	
	while (*str != '\0')
	{
		if (*str == '\n')    //\n̎\r\nɕϊ
		{
			sci_write_char('\r');
		}
		sci_write_char((unsigned char)*str++);
	}
}

void sci_write_flush(void)
{
	//Mobt@̃f[^̏o͂I܂ő҂֐
	
	while (g_sci_send_flag != FLAG_CLEAR)
	{
		NOP_MCU_DEP;
	}
}

unsigned short sci_read_char(unsigned char *c)
{
	//Mobt@1ǂݏo֐
	
	//
	//  unsigned char *c : Mf[^
	//߂l
	//  0 : Mf[^
	//  0xFFFF(SCI_RECEIVE_DATA_EMPTY) : Mf[^Ȃ
	
	if (g_sci_recv_buf_index1 == g_sci_recv_buf_index2)
	{
		return (unsigned short)SCI_RECEIVE_DATA_EMPTY;
	}

	g_sci_recv_buf_index2++;
	if (g_sci_recv_buf_index2 >= SCI_RECV_BUF_SIZE) g_sci_recv_buf_index2 = 0;
	*c = g_sci_recv_buf[g_sci_recv_buf_index2];
	
	return 0;
}

unsigned short sci_read_str(char *str, unsigned short size)
{
	//Mobt@ǂݏo֐
	
	//
	//  char *str : Mf[^
	//  unsigned short size : oCg
	//߂l
	//  0 : I
	//  0xFFFF(SCI_RECEIVE_DATA_EMPTY) : w肳ꂽsizẽf[^MĂȂ
	
	unsigned short data_receive_size;
	unsigned short i;
	
	data_receive_size = sci_read_data_size();
	
	if (size > data_receive_size)
	{
		return (unsigned short)SCI_RECEIVE_DATA_EMPTY;
	}
	
	for (i=0; i<size; i++)
	{
		g_sci_recv_buf_index2++;
		if (g_sci_recv_buf_index2 >= SCI_RECV_BUF_SIZE) g_sci_recv_buf_index2 = 0;
		
		*str++ = (char)g_sci_recv_buf[g_sci_recv_buf_index2];
	}
	
	return 0;
}

unsigned short sci_read_data_size(void)
{
	//Mobt@i[ς݃f[^o͊֐
	
	//߂l
	//  0 : Mobt@ɎMf[^Ȃ
	// >0 : Mobt@ɗ܂Ăf[^oCg
	
	unsigned short ret;
	unsigned short local_sci_recv_buf_index1;
	
	//g_sci_recv_buf_index1͊荞݂ŐXV\̂ōŏɃRs[Ă
	//irōXVĂ{֐ł̓Rs[_̃TCYŏj
	local_sci_recv_buf_index1 = g_sci_recv_buf_index1;
	
	if (local_sci_recv_buf_index1 >= g_sci_recv_buf_index2)
	{
		ret = (unsigned short)(local_sci_recv_buf_index1 - g_sci_recv_buf_index2);
	}
	else
	{
		ret = (unsigned short)(SCI_RECV_BUF_SIZE + local_sci_recv_buf_index1 - g_sci_recv_buf_index2);
	}
	
	return ret;
}

void sci_read_buf_clear(void)
{
	//Mobt@Ɋi[Ăf[^NA֐
	
	g_sci_recv_buf_index2 = g_sci_recv_buf_index1;
}

int float2str(float value, int num, char *str)
{
	//floatϊ֐
	
	//߂l
	//  0 : G[Ȃ
	// -1 : G[
	// -2 :  2^32-1(4294967295)ŕ\ł鐔l𒴂Ă
	
	//
	//  float value : ϊl
	//  int num     : _ȉ(0-8)
	//  char *str   : ߂l|C^
	
	float f1;
	float add_f1;           //ľܓɉZ
	unsigned long l1, l2;
	unsigned char buf[10];
	
	int i, j;
	
	*str = '\0';
	
	if (num > 8) return -1;
	if (num < 0) return -1;
	
	//
	if (value < 0)
	{
		f1 = value * -1.0f;
		*str++ = '-';
	}
	else
	{
		f1 = value;
	}
	
	//ľܓ
	switch (num)
	{
		case 0:
			add_f1 = 0.5f;
			break;
		case 1:
			add_f1 = 0.05f;
			break;
		case 2:
			add_f1 = 0.005f;
			break;
		case 3:
			add_f1 = 0.0005f;
			break;
		case 4:
			add_f1 = 0.00005f;
			break;
		case 5:
			add_f1 = 0.000005f;
			break;
 		case 6:
			add_f1 = 0.0000005f;
			break;
		case 7:
			add_f1 = 0.00000005f;
			break;
		case 8:
			add_f1 = 0.000000005f;
			break;
		default:
			break;
	}
	
	f1 += add_f1;
	
	if (f1 > 4294967295)
	{
		//I[ot[
		
		*str++ = 'O';
		*str++ = 'V';
		*str++ = 'F';
		*str = '\0';
		
		return -2;
	}
	
	//
	l1 = (unsigned long)f1;
	
	//   1234567890
	l2 = 1000000000;
	
	for (i=0; i<10; i++)
	{
		buf[i] = (unsigned char)(l1 / l2);
		
		if (i == 9) break;
		
		l1 -= buf[i] * l2;
		
		l2 /= 10;
	}
	
	for (i=0; i<10; i++)
	{
		if (buf[i] != 0) break;
	}
	
	if (i == 10)
	{
		*str++ = '0';
	}
	else
	{
		for (j=i; j<10; j++)
		{
			*str++ = (char)(buf[j] + '0');
		}
	}
	
	//
	if (num == 0)
	{
		*str='\0';
		return 0;
	}
	
	switch (num)
	{
		case 1:
			l2 = 10;
			break;
		case 2:
			l2 = 100;
			break;
		case 3:
			l2 = 1000;
			break;
		case 4:
			l2 = 10000;
			break;
		case 5:
			l2 = 100000;
			break;
		case 6:
			l2 = 1000000;
			break;
		case 7:
			l2 = 10000000;
			break;
		case 8:
			l2 = 100000000;
			break;
		default:
			break;
	}
	
	f1 = f1 - (float)((unsigned long)f1);
	
	l1 = (unsigned long)(f1 * (float)l2);
	l2 /= 10;
	
	for (i=0; i<=(num-1); i++)
	{
		buf[i] = (unsigned char)(l1 / l2);
		
		if (i == (num-1)) break;
		
		l1 -= buf[i] * l2;
		
		l2 /= 10;
	}
	
	*str++ = '.';
	
	for (i=0; i<=(num-1); i++)
	{
		*str++ = (char)(buf[i] + '0');
	}
	
    *str='\0';
	
    return 0;
}

int float2str_eformat(float value, int num, char *str)
{
	//floatϊ֐, oe`
	
	//߂l
	//  0 : G[Ȃ
	// -1 : G[
	
	//
	//  float value : ϊl
	//  int num     : _ȉ(0-8)
	//  char *str   : ߂l|C^
	
	float f1;
	short s = 0;
	unsigned short i;
	char buf[20];
	int ret;
	
	*str = '\0';
	
	if (num > 8) return -1;
	if (num < 0) return -1;
	
	//
	if (value < 0)
	{
		f1 = value * -1.0f;
		*str++ = '-';
	}
	else
	{
		f1 = value;
	}
	
	if (f1 > 10.0f)
	{
		for (i=0; i<39; i++)
		{
			f1 /= 10.0f;
			s++;
			if (f1 < 10.0f) break;
		}
	}
	else if (f1 < 1.0f)
	{
		for (i=0; i<39; i++)
		{
			f1 *= 10.0f;
			s--;
			if (f1 > 1.0f) break;
		}
	}
	
	ret = float2str(f1, num, buf);
	if (ret != 0)
	{
		*str = '\0';
		return ret;
	}
	
	i = 0;
	while (buf[i] != '\0')
	{
		*str++ = buf[i++];
	}
	
	*str++ = 'e';
	
	ret = float2str((float)s, 0, buf);
	if (ret != 0)
	{
		*str = '\0';
		return ret;
	}
	
	i = 0;
	while (buf[i] != '\0')
	{
		*str++ = buf[i++];
	}
		
	*str='\0';
	
	return 0;
}
	
int double2str(double value, int num, char *str)
{
	//doubleϊ֐
	
	//߂l
	//  0 : G[Ȃ
	// -1 : G[
	// -2 :  2^32-1(4294967295)ŕ\ł鐔l𒴂Ă
	
	//
	//  double value : ϊl
	//  int num     : _ȉ(0-8)
	//  char *str   : ߂l|C^
	
	double d1;
	double add_d1;           //ľܓɉZ
	unsigned long l1, l2;
	unsigned char buf[10];
	
	int i, j;
	
	*str = '\0';
	
	if (num > 8) return -1;
	if (num < 0) return -1;
	
	//
	if (value < 0)
	{
		d1 = value * -1.0;
		*str++ = '-';
	}
	else
	{
		d1 = value;
	}
	
	//ľܓ
	switch (num)
	{
		case 0:
			add_d1 = 0.5;
			break;
		case 1:
			add_d1 = 0.05;
			break;
		case 2:
			add_d1 = 0.005;
			break;
		case 3:
			add_d1 = 0.0005;
			break;
		case 4:
			add_d1 = 0.00005;
			break;
		case 5:
			add_d1 = 0.000005;
			break;
 		case 6:
			add_d1 = 0.0000005;
			break;
		case 7:
			add_d1 = 0.00000005;
			break;
		case 8:
			add_d1 = 0.000000005;
			break;
		default:
			break;
	}
	
	d1 += add_d1;
	
	if (d1 > 4294967295)
	{
		//I[ot[
		
		*str++ = 'O';
		*str++ = 'V';
		*str++ = 'F';
		*str = '\0';
		
		return -2;
	}
	
	//
	l1 = (unsigned long)d1;
	
	//   1234567890
	l2 = 1000000000;
	
	for (i=0; i<10; i++)
	{
		buf[i] = (unsigned char)(l1 / l2);
		
		if (i == 9) break;
		
		l1 -= buf[i] * l2;
		
		l2 /= 10;
	}
	
	for (i=0; i<10; i++)
	{
		if (buf[i] != 0) break;
	}
	
	if (i == 10)
	{
		*str++ = '0';
	}
	else
	{
		for (j=i; j<10; j++)
		{
			*str++ = (char)(buf[j] + '0');
		}
	}
	
	//
	if (num == 0)
	{
		*str='\0';
		return 0;
	}
	
	switch (num)
	{
		case 1:
			l2 = 10;
			break;
		case 2:
			l2 = 100;
			break;
		case 3:
			l2 = 1000;
			break;
		case 4:
			l2 = 10000;
			break;
		case 5:
			l2 = 100000;
			break;
		case 6:
			l2 = 1000000;
			break;
		case 7:
			l2 = 10000000;
			break;
		case 8:
			l2 = 100000000;
			break;
		default:
			break;
	}
	
	d1 = d1 - (double)((unsigned long)d1);
	
	l1 = (unsigned long)(d1 * (double)l2);
	l2 /= 10;
	
	for (i=0; i<=(num-1); i++)
	{
		buf[i] = (unsigned char)(l1 / l2);
		
		if (i == (num-1)) break;
		
		l1 -= buf[i] * l2;
		
		l2 /= 10;
	}
	
	*str++ = '.';
	
	for (i=0; i<=(num-1); i++)
	{
		*str++ = (char)(buf[i] + '0');
	}
	
    *str='\0';
	
    return 0;
}

int double2str_eformat(double value, int num, char *str)
{
	//doubleϊ֐, oe`
	
	//߂l
	//  0 : G[Ȃ
	// -1 : G[
	
	//
	//  double value : ϊl
	//  int num     : _ȉ(0-8)
	//  char *str   : ߂l|C^
	
	double d1;
	short s = 0;
	unsigned short i;
	char buf[20];
	int ret;
	
	*str = '\0';
	
	if (num > 8) return -1;
	if (num < 0) return -1;
	
	//
	if (value < 0)
	{
		d1 = value * -1.0;
		*str++ = '-';
	}
	else
	{
		d1 = value;
	}
	
	if (d1 > 10.0)
	{
		for (i=0; i<309; i++)
		{
			d1 /= 10.0;
			s++;
			if (d1 < 10.0) break;
		}
	}
	else if (d1 < 1.0)
	{
		for (i=0; i<309; i++)
		{
			d1 *= 10.0f;
			s--;
			if (d1 > 1.0f) break;
		}
	}
	
	ret = double2str(d1, num, buf);
	if (ret != 0)
	{
		*str = '\0';
		return ret;
	}
	
	i = 0;
	while (buf[i] != '\0')
	{
		*str++ = buf[i++];
	}
	
	*str++ = 'e';
	
	ret = double2str((double)s, 0, buf);
	if (ret != 0)
	{
		*str = '\0';
		return ret;
	}
	
	i = 0;
	while (buf[i] != '\0')
	{
		*str++ = buf[i++];
	}
		
	*str='\0';
	
	return 0;
}

/*----------------------------------------------------------------------
	\[XR[hi[Jj
----------------------------------------------------------------------*/

static int interrupt_flag_get(void)
{
	int ret;
	
#if defined(MCU_TYPE_RX)

	unsigned long psw;
	
	psw = __get_psw() & 0x00010000UL;
	
	ret = psw >> 16UL;
	
#endif

#if defined(MCU_TYPE_RL78)

	unsigned char psw;
	
	psw = __get_psw();
	
	ret = psw >> 7;
	
#endif

#if defined(MCU_TYPE_RA)
	
	ret = __get_PRIMASK() ? 0 : 1;
	
#endif

#if defined(MCU_TYPE_RH850)

	unsigned long psw;
	
	psw = __stsr(5) & 0x00000020UL;
	
	ret = psw ? 0 : 1;
	
#endif

	return ret;
}

/*----------------------------------------------------------------------
	\[XR[hi荞݂ŌĂяo֐j
----------------------------------------------------------------------*/

void intr_sci_send_end(void)
{
	//MɎs鏈
	
	//MɃEif[^i[pjobt@Ƀf[^Ȃ
	if (g_sci_send_buf_index[g_sci_send_buf_page_index] == 0)
	{
		g_sci_send_flag = FLAG_CLEAR;
	}
	else
	{
		//M֐LbN
		
#if defined(MCU_TYPE_RH850)
		
		//Oqu-RH850ł̑MCu֐Ăяo̒ӓ_-vQ
		
		while(MD_ERROR == SCI_SEND(&g_sci_send_buf[g_sci_send_buf_page_index][0], g_sci_send_buf_index[g_sci_send_buf_page_index]) )
		{
			NOP_MCU_DEP;
		}
#else
		SCI_SEND(&g_sci_send_buf[g_sci_send_buf_page_index][0], g_sci_send_buf_index[g_sci_send_buf_page_index]);
#endif
		
		g_sci_send_buf_index[g_sci_send_buf_page_index] = 0;	//i[ς݃CfbNXNA
		
		g_sci_send_buf_page_index++;	//Mobt@̃y[W؂ւ
		if (g_sci_send_buf_page_index >= 2) g_sci_send_buf_page_index = 0;
	}
}

void intr_sci_receive_end(void)
{
	//MɎs鏈
	
	g_sci_recv_buf_index1++;
	if (g_sci_recv_buf_index1 >= SCI_RECV_BUF_SIZE) g_sci_recv_buf_index1 = 0;

	g_sci_recv_buf[g_sci_recv_buf_index1] = g_sci_recv_data;

	if (g_sci_recv_buf_index1 == g_sci_recv_buf_index2)      //݃CfbNXǂݏoCfbNX𒴂
	{
		g_sci_recv_buf_index2 = (unsigned short)(g_sci_recv_buf_index1 + 1);
		if (g_sci_recv_buf_index2 >= SCI_RECV_BUF_SIZE) g_sci_recv_buf_index2 = 0;
		//̎_Ŗǂݏõf[^͎̂Ă邪AŐV SCI_RECV_BUF_SIZE ̃f[^͖ǂݏoŗLƂ
		g_sci_status |= SCI_RECEIVE_BUF_OVERFLOW;
	}
	
	//̃f[^M
    SCI_RECEIVE(&g_sci_recv_data, 1);
}

void intr_sci_receive_error(void)
{
	//MG[Ɏs鏈
	
	//X}[gRtBO[^/FSPR[hSSR̃G[NA͍sĂ
	
	//RL78̏ꍇ́ASSR̃G[NAɖ{֐Ă΂
	//RL78̓\tgEFAI[ȍꍇR[obN֐Ă΂邪{vOł͖gp
	
	//RX̏ꍇ́ASSRG[NAOɖ{֐Ă΂
	//{֐SSRmF΁AG[e͔邪SCI-chɉČ郌WX^ςȂ΂ȂȂ̂
	//{vOł̓G[ʂ̎擾͍sĂȂ
	
	//RȀꍇ́ASSR̃G[NAɖ{֐Ă΂邪G[tO͕ێĂ
	
	g_sci_status |= SCI_RECEIVE_ERROR;
	
}

#if defined(MCU_TYPE_RA)

//RAUART荞ݏ

void user_uart_callback (uart_callback_args_t * p_args)
{
	/* Handle the UART event */
	switch (p_args->event)
	{
		/* Received a character */
		case UART_EVENT_RX_CHAR:
		{
			//9bitȏ̃f[^Mۂ͏L
			break;
		}
		/* Receive complete */
		case UART_EVENT_RX_COMPLETE:
		{
			intr_sci_receive_end();
			break;
		}
		/* Transmit complete */
		case UART_EVENT_TX_COMPLETE:
		{
			intr_sci_send_end();
			break;
		}
		/* error */
		case UART_EVENT_ERR_FRAMING:
		{
			g_sci_status |= SCI_RECEIVE_FRAMING_ERROR;
			intr_sci_receive_error();
			break;
		}
		case UART_EVENT_ERR_OVERFLOW:
		{
			g_sci_status |= SCI_RECEIVE_OVERRUN_ERROR;
			intr_sci_receive_error();
			break;
		}
		default:
		{
		}
	}
}
#endif
